# Generated by Django 2.2.24 on 2021-12-01 21:24

import uuid

import django.contrib.gis.db.models.fields
import django.contrib.postgres.fields.jsonb
import django.core.validators
import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("geodata", "0001_initial"),
        ("management", "0001_initial"),
        ("dicts", "0001_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Metaplace",
            fields=[
                (
                    "id_metaplace",
                    models.AutoField(db_index=True, primary_key=True, serialize=False),
                ),
                (
                    "name",
                    models.CharField(
                        db_index=True, max_length=255, verbose_name="nom du métasite"
                    ),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                (
                    "geom",
                    django.contrib.gis.db.models.fields.PolygonField(
                        blank=True, null=True, srid=4326, verbose_name="Enveloppe du métasite"
                    ),
                ),
                (
                    "autogeom",
                    models.BooleanField(
                        db_index=True,
                        default=True,
                        help_text="La géométrie sera automatiquement générée selon les localités associés au métasite. Décocher l'option pour dessiner un polygone à main levée.",
                        verbose_name="Géométrie automatiquement générée",
                    ),
                ),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="metaplace_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "type",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.MetaplaceType",
                        verbose_name="Type de métasite",
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="metaplace_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Métasite",
                "verbose_name_plural": "Métasites",
            },
        ),
        migrations.CreateModel(
            name="Place",
            fields=[
                ("id_place", models.AutoField(db_index=True, primary_key=True, serialize=False)),
                ("uuid", models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                (
                    "name",
                    models.CharField(db_index=True, max_length=255, verbose_name="nom du lieu"),
                ),
                (
                    "is_hidden",
                    models.BooleanField(
                        db_index=True, default=False, verbose_name="Site sensible"
                    ),
                ),
                (
                    "is_gite",
                    models.BooleanField(db_index=True, default=False, verbose_name="Est un gîte"),
                ),
                (
                    "is_managed",
                    models.BooleanField(db_index=True, default=False, verbose_name="Site géré"),
                ),
                (
                    "proprietary",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        max_length=100,
                        null=True,
                        verbose_name="Nom du propriétaire",
                    ),
                ),
                (
                    "convention",
                    models.BooleanField(default=False, verbose_name="Convention refuge"),
                ),
                (
                    "convention_file",
                    models.FileField(
                        blank=True,
                        null=True,
                        upload_to="place/convention/",
                        verbose_name="Exemplaire de la convention",
                    ),
                ),
                (
                    "map_file",
                    models.FileField(
                        blank=True,
                        null=True,
                        upload_to="place/map/",
                        verbose_name="Carte détaillée, topo, etc.",
                    ),
                ),
                (
                    "photo_file",
                    models.ImageField(
                        blank=True,
                        null=True,
                        upload_to="photo/",
                        verbose_name="Photo de la localité",
                    ),
                ),
                (
                    "habitat",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Habitat"
                    ),
                ),
                (
                    "altitude",
                    models.PositiveIntegerField(
                        blank=True,
                        null=True,
                        validators=[
                            django.core.validators.MaxValueValidator(4800),
                            django.core.validators.MinValueValidator(-20),
                        ],
                        verbose_name="Altitude",
                    ),
                ),
                ("id_bdcavite", models.CharField(blank=True, max_length=15, null=True)),
                (
                    "plan_localite",
                    models.FileField(
                        blank=True,
                        null=True,
                        upload_to="place/plan_localite/",
                        verbose_name="Plan du site et/ou topo de la cavité",
                    ),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                (
                    "other_imported_data",
                    models.TextField(
                        blank=True, null=True, verbose_name="Autres données importées"
                    ),
                ),
                (
                    "telemetric_crossaz",
                    models.BooleanField(
                        default=False, verbose_name="Croisement d\xa0'azimuth télémétrique"
                    ),
                ),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                (
                    "x",
                    models.FloatField(
                        blank=True,
                        help_text="Coordonnées est-ouest en WGS84 (projection habituelle des gps)",
                        null=True,
                        verbose_name="Longitude",
                    ),
                ),
                (
                    "y",
                    models.FloatField(
                        blank=True,
                        help_text="Coordonnées nord-sud en WGS84 (projection habituelle des gps)",
                        null=True,
                        verbose_name="Latitude",
                    ),
                ),
                (
                    "geom",
                    django.contrib.gis.db.models.fields.PointField(
                        blank=True, null=True, srid=4326, verbose_name="Localisation géographique"
                    ),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True, db_index=True)),
                (
                    "authorized_user",
                    models.ManyToManyField(
                        blank=True,
                        related_name="hiddenplaceauthuser",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Personnes authorisées si site sensible",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="place_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "domain",
                    models.ForeignKey(
                        blank=True,
                        max_length=100,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.PropertyDomain",
                        verbose_name="Domaine",
                    ),
                ),
                (
                    "landcover",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="geodata.LandCover",
                        verbose_name="Occupation du sol",
                    ),
                ),
                (
                    "metaplace",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="sights.Metaplace",
                        verbose_name="Métasite associé",
                    ),
                ),
                (
                    "municipality",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="geodata.Municipality",
                        verbose_name="Commune",
                    ),
                ),
                (
                    "precision",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.PlacePrecision",
                        verbose_name="Précision géographique",
                    ),
                ),
                (
                    "territory",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="geodata.Territory",
                        verbose_name="Territoire",
                    ),
                ),
                (
                    "type",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TypePlace",
                        verbose_name="Type de gîte",
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="place_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Localité",
                "verbose_name_plural": "Localités",
                "unique_together": {("name", "municipality", "type")},
            },
        ),
        migrations.CreateModel(
            name="Session",
            fields=[
                ("id_session", models.AutoField(primary_key=True, serialize=False)),
                ("uuid", models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                (
                    "name",
                    models.CharField(
                        blank=True, max_length=150, verbose_name="Intitulé de la session"
                    ),
                ),
                (
                    "date_start",
                    models.DateField(
                        help_text="Format de date: <em>01/01/2017</em>.",
                        verbose_name="Date de début",
                    ),
                ),
                (
                    "time_start",
                    models.TimeField(
                        blank=True,
                        help_text="Format d'heure: <em>02:15</em>.",
                        null=True,
                        verbose_name="Heure de début",
                    ),
                ),
                (
                    "date_end",
                    models.DateField(
                        blank=True,
                        help_text="Format de date: <em>01/01/2017</em>.",
                        null=True,
                        verbose_name="Date de fin",
                    ),
                ),
                (
                    "time_end",
                    models.TimeField(
                        blank=True,
                        help_text="Format d'heure: <em>02:15</em>.",
                        null=True,
                        verbose_name="Heure de fin",
                    ),
                ),
                (
                    "data_file",
                    models.FileField(
                        blank=True,
                        null=True,
                        upload_to="session/file/",
                        verbose_name="Fichier de données (tableur d'analyse acoustique, fiche de terrain, etc.)",
                    ),
                ),
                (
                    "is_confidential",
                    models.BooleanField(default=False, verbose_name="Données confidentielles"),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.TextField(blank=True, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "contact",
                    models.ForeignKey(
                        default=10,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.Contact",
                        verbose_name="Type de contact",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="session_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "main_observer",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="mainobs",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "other_observer",
                    models.ManyToManyField(
                        blank=True, related_name="otherobs", to=settings.AUTH_USER_MODEL
                    ),
                ),
                (
                    "place",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="sessions",
                        to="sights.Place",
                        verbose_name="Localité associée",
                    ),
                ),
                (
                    "study",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        related_name="sessions",
                        to="management.Study",
                        verbose_name="Etude",
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="session_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Session d'inventaire/observations",
                "verbose_name_plural": "Sessions d'inventaire/observations",
                "unique_together": {("place", "contact", "date_start")},
            },
        ),
        migrations.CreateModel(
            name="Tree",
            fields=[
                ("id_tree", models.AutoField(primary_key=True, serialize=False)),
                ("visit_date", models.DateField(help_text="Date de visite", verbose_name="Date")),
                (
                    "situation",
                    models.CharField(
                        blank=True,
                        help_text="... dans le milieu (dans le bois, en lisière, etc.)",
                        max_length=100,
                        null=True,
                        verbose_name="Situation",
                    ),
                ),
                (
                    "tree_diameter",
                    models.PositiveIntegerField(
                        blank=True,
                        help_text="à 1.30m du sol, en cm",
                        null=True,
                        validators=[django.core.validators.MaxValueValidator(500)],
                        verbose_name="Diamètre",
                    ),
                ),
                ("standing", models.NullBooleanField(verbose_name="Arbre debout")),
                ("protected", models.NullBooleanField(verbose_name="Arbre protégé")),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "bat_specie",
                    models.ManyToManyField(
                        blank=True,
                        related_name="treebatspecie",
                        to="dicts.Specie",
                        verbose_name="Espèces observées",
                    ),
                ),
                (
                    "circumstance",
                    models.ForeignKey(
                        blank=True,
                        help_text="Circonstance de la découverte",
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeCircumstance",
                        verbose_name="Circonstance",
                    ),
                ),
                (
                    "context",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeContext",
                        verbose_name="Contexte",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="tree_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "forest_stands",
                    models.ForeignKey(
                        blank=True,
                        help_text="Peuplement forestier",
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeForestStands",
                        verbose_name="Peuplement",
                    ),
                ),
                (
                    "gite_localisation",
                    models.ManyToManyField(
                        blank=True,
                        to="dicts.TreeGitePlace",
                        verbose_name="Emplacement du/des gîte(s)",
                    ),
                ),
                (
                    "gite_origin",
                    models.ManyToManyField(
                        blank=True,
                        to="dicts.TreeGiteOrigin",
                        verbose_name="Origines du/des gîte(s)",
                    ),
                ),
                (
                    "gite_type",
                    models.ManyToManyField(
                        blank=True, to="dicts.TreeGiteType", verbose_name="Types de gîte(s)"
                    ),
                ),
                (
                    "health",
                    models.ForeignKey(
                        blank=True,
                        help_text="Etat sanitaire",
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeHealth",
                        verbose_name="Etat",
                    ),
                ),
                (
                    "place",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="sights.Place"
                    ),
                ),
                (
                    "tree_specie",
                    models.ForeignKey(
                        blank=True,
                        help_text="Espèce de l'arbre",
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeSpecies",
                        verbose_name="Espèce",
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="tree_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Détail d'un arbre",
                "verbose_name_plural": "Détails des arbres",
                "unique_together": {("visit_date", "place")},
            },
        ),
        migrations.CreateModel(
            name="TreeGite",
            fields=[
                ("id_treegite", models.AutoField(primary_key=True, serialize=False)),
                (
                    "gite_high",
                    models.PositiveIntegerField(
                        blank=True,
                        null=True,
                        verbose_name="Hauteur gîte (au plus haut point d’accès)",
                    ),
                ),
                (
                    "gite_tree_diameter",
                    models.DecimalField(
                        blank=True,
                        decimal_places=1,
                        help_text="en cm",
                        max_digits=3,
                        null=True,
                        verbose_name="Diamètre (branche, tronc) à hauteur du gîte",
                    ),
                ),
                (
                    "gite_access_orientation",
                    models.CharField(
                        blank=True,
                        max_length=50,
                        null=True,
                        verbose_name="Orientation du ou des accès",
                    ),
                ),
                (
                    "gite_access_size",
                    models.FloatField(
                        blank=True,
                        null=True,
                        verbose_name="largeur ou diamètre de l'ouverture en cm",
                    ),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "bat_specie",
                    models.ManyToManyField(
                        blank=True,
                        related_name="treegitebatspecie",
                        to="dicts.Specie",
                        verbose_name="Espèces observées",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="treegite_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "gite_localisation",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeGitePlace",
                        verbose_name="Emplacement du gîte",
                    ),
                ),
                (
                    "gite_origin",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeGiteOrigin",
                        verbose_name="Origine du gîte",
                    ),
                ),
                (
                    "gite_type",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.TreeGiteType",
                        verbose_name="Type de gîte",
                    ),
                ),
                (
                    "tree",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="sights.Tree"
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="treegite_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Détail des gîtes d'un arbre",
                "verbose_name_plural": "Détails des gîtes d'un arbre",
            },
        ),
        migrations.CreateModel(
            name="Sighting",
            fields=[
                (
                    "id_sighting",
                    models.AutoField(primary_key=True, serialize=False, verbose_name="id unique"),
                ),
                ("uuid", models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                (
                    "period",
                    models.CharField(
                        blank=True, max_length=50, null=True, verbose_name="Période d'observation"
                    ),
                ),
                (
                    "total_count",
                    models.PositiveIntegerField(
                        blank=True,
                        help_text="Désactivé pour les données acoustiques et en main",
                        null=True,
                        verbose_name="Nombre total",
                    ),
                ),
                ("breed_colo", models.NullBooleanField(verbose_name="Colonie de reproduction")),
                (
                    "is_doubtful",
                    models.BooleanField(default=False, verbose_name="Donnée douteuse"),
                ),
                (
                    "id_bdsource",
                    models.TextField(
                        blank=True, null=True, verbose_name="id unique de la bdd source"
                    ),
                ),
                (
                    "bdsource",
                    models.CharField(
                        blank=True, max_length=100, null=True, verbose_name="bdd source"
                    ),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True, db_index=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "codesp",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.Specie",
                        verbose_name="Espèce ou groupe d'espèce",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="sighting_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "observer",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="sightingobs",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Observateur",
                    ),
                ),
                (
                    "session",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="observations",
                        to="sights.Session",
                        verbose_name="Session associée",
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="sighting_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Observation",
                "verbose_name_plural": "Observations",
                "unique_together": {("codesp", "session")},
            },
        ),
        migrations.CreateModel(
            name="PlaceManagement",
            fields=[
                ("id_placemanagement", models.AutoField(primary_key=True, serialize=False)),
                ("date", models.DateField(verbose_name="Date")),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                (
                    "file",
                    models.FileField(
                        blank=True,
                        help_text="Si vous voulez charger plusieurs fichiers, créez une archive avec un logiciel de compression comme 7zip",
                        null=True,
                        upload_to="place/management/",
                        verbose_name="Fichier",
                    ),
                ),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "action",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.PlaceManagementAction",
                        verbose_name="Action",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="placemanagement_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "place",
                    models.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="management",
                        to="sights.Place",
                    ),
                ),
                (
                    "referent",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Référent de l'action",
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="placemanagement_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Action de gestion",
                "verbose_name_plural": "Actions de gestion",
            },
        ),
        migrations.CreateModel(
            name="Device",
            fields=[
                ("id_device", models.AutoField(primary_key=True, serialize=False)),
                (
                    "ref",
                    models.CharField(
                        default="nd",
                        max_length=30,
                        verbose_name="Référence du dispositif pour la session",
                    ),
                ),
                (
                    "height",
                    models.FloatField(blank=True, default=None, null=True, verbose_name="Hauteur"),
                ),
                (
                    "width",
                    models.FloatField(blank=True, default=None, null=True, verbose_name="Largeur"),
                ),
                (
                    "context",
                    models.CharField(
                        blank=True,
                        default=None,
                        max_length=150,
                        null=True,
                        verbose_name="Contexte",
                    ),
                ),
                (
                    "photo_file",
                    models.ImageField(
                        blank=True,
                        default=None,
                        null=True,
                        upload_to="photo/",
                        verbose_name="Photo du dispositif",
                    ),
                ),
                (
                    "id_fromsrc",
                    models.CharField(
                        blank=True,
                        max_length=100,
                        null=True,
                        verbose_name="id unique de la bdd source",
                    ),
                ),
                (
                    "bdsource",
                    models.CharField(
                        blank=True, max_length=100, null=True, verbose_name="bdd source"
                    ),
                ),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="device_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "session",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="sights.Session",
                        verbose_name="Session associée",
                    ),
                ),
                (
                    "type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="dicts.TypeDevice"
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="device_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="CountDetail",
            fields=[
                ("id_countdetail", models.AutoField(primary_key=True, serialize=False)),
                ("uuid", models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                (
                    "count",
                    models.PositiveIntegerField(blank=True, null=True, verbose_name="Effectif"),
                ),
                (
                    "time",
                    models.TimeField(
                        blank=True, help_text="au format hh:mm", null=True, verbose_name="Heure"
                    ),
                ),
                (
                    "ab",
                    models.FloatField(blank=True, help_text="en mm", null=True, verbose_name="AB"),
                ),
                (
                    "d5",
                    models.FloatField(blank=True, help_text="en mm", null=True, verbose_name="D5"),
                ),
                (
                    "d3",
                    models.FloatField(blank=True, help_text="en mm", null=True, verbose_name="D3"),
                ),
                (
                    "pouce",
                    models.FloatField(
                        blank=True, help_text="en mm", null=True, verbose_name="Pouce"
                    ),
                ),
                (
                    "queue",
                    models.FloatField(
                        blank=True, help_text="en mm", null=True, verbose_name="Queue"
                    ),
                ),
                (
                    "tibia",
                    models.FloatField(
                        blank=True, help_text="en mm", null=True, verbose_name="Tibia"
                    ),
                ),
                (
                    "pied",
                    models.FloatField(
                        blank=True, help_text="en mm", null=True, verbose_name="Pied"
                    ),
                ),
                (
                    "cm3",
                    models.FloatField(
                        blank=True, help_text="en mm", null=True, verbose_name="CM3"
                    ),
                ),
                (
                    "tragus",
                    models.FloatField(
                        blank=True, help_text="en mm", null=True, verbose_name="Tragus"
                    ),
                ),
                (
                    "poids",
                    models.FloatField(
                        blank=True, help_text="en g", null=True, verbose_name="Poids"
                    ),
                ),
                (
                    "etat_sexuel",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=2,
                        null=True,
                        verbose_name="Etat sexuel",
                    ),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                (
                    "id_fromsrc",
                    models.CharField(
                        blank=True,
                        max_length=100,
                        null=True,
                        verbose_name="id unique de la bdd source",
                    ),
                ),
                (
                    "bdsource",
                    models.CharField(
                        blank=True, max_length=100, null=True, verbose_name="bdd source"
                    ),
                ),
                (
                    "other_imported_data",
                    models.TextField(
                        blank=True, null=True, verbose_name="Autres données importées"
                    ),
                ),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "age",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.Age",
                        verbose_name="Age estimé",
                    ),
                ),
                (
                    "chinspot",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomChinspot",
                        verbose_name="Tâche mentonière",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="countdetail_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "device",
                    models.ForeignKey(
                        blank=True,
                        default=None,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="sights.Device",
                        verbose_name="Dispositif",
                    ),
                ),
                (
                    "epididyme",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomEpipidyme",
                        verbose_name="Epididymes",
                    ),
                ),
                (
                    "epiphyse",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomEpiphyse",
                        verbose_name="Epiphyse articulaire",
                    ),
                ),
                (
                    "gestation",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomGestation",
                        verbose_name="Gestation",
                    ),
                ),
                (
                    "gland_coul",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomGlandCoul",
                        verbose_name="couleur des glandes",
                    ),
                ),
                (
                    "gland_taille",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomGlandTaille",
                        verbose_name="Taille des glandes",
                    ),
                ),
                (
                    "mamelle",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomMamelle",
                        verbose_name="Mamelles",
                    ),
                ),
                (
                    "manipulator",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="observer",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Manipulateur",
                    ),
                ),
                (
                    "method",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.Method",
                        verbose_name="Méthode",
                    ),
                ),
                (
                    "precision",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.CountPrecision",
                        verbose_name="Précision du comptage",
                    ),
                ),
                (
                    "sex",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.Sex",
                        verbose_name="Sexe",
                    ),
                ),
                (
                    "sighting",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="countdetails",
                        to="sights.Sighting",
                    ),
                ),
                (
                    "testicule",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomTesticule",
                        verbose_name="Testicules",
                    ),
                ),
                (
                    "transmitter",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="management.Transmitter",
                        verbose_name="Emetteur de télémétrie",
                    ),
                ),
                (
                    "tuniq_vag",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomTuniqVag",
                        verbose_name="Tuniques vaginales",
                    ),
                ),
                (
                    "unit",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.CountUnit",
                        verbose_name="Unité",
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="countdetail_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "usure_dent",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.BiomDent",
                        verbose_name="Usure des dents",
                    ),
                ),
                (
                    "validator",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="validator",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Validateur",
                    ),
                ),
            ],
            options={
                "verbose_name": "4 ∙ Comptage détaillé",
                "verbose_name_plural": "4 ∙ Comptages détaillés",
            },
        ),
        migrations.CreateModel(
            name="SessionLink",
            fields=[
                (
                    "id_session_link",
                    models.AutoField(primary_key=True, serialize=False, verbose_name="id unique"),
                ),
                ("link", models.URLField(help_text="http(s)://...", verbose_name="Hyperlien")),
                (
                    "comment",
                    models.CharField(
                        blank=True, max_length=500, null=True, verbose_name="Commentaire"
                    ),
                ),
                (
                    "session",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="session_link_related",
                        related_query_name="session_links",
                        to="sights.Session",
                    ),
                ),
                (
                    "type_link",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.LinkType",
                        verbose_name="Type de lien",
                    ),
                ),
            ],
            options={
                "unique_together": {("link", "session")},
            },
        ),
        migrations.CreateModel(
            name="Cave",
            fields=[
                ("id_cave", models.AutoField(primary_key=True, serialize=False)),
                (
                    "bd_cavite",
                    models.CharField(
                        blank=True,
                        max_length=20,
                        null=True,
                        verbose_name="Identifiant de la BD Cavités du BRGM",
                    ),
                ),
                ("visit_date", models.DateField()),
                (
                    "length",
                    models.PositiveIntegerField(
                        blank=True, null=True, verbose_name="Développement"
                    ),
                ),
                (
                    "altdiff",
                    models.IntegerField(
                        blank=True, null=True, verbose_name="Dénivellé vers la cavité"
                    ),
                ),
                (
                    "n_entry",
                    models.PositiveIntegerField(
                        blank=True, null=True, verbose_name="Nombre dentrées"
                    ),
                ),
                ("equip_req", models.NullBooleanField(verbose_name="Equipement requis?")),
                (
                    "equipment",
                    models.TextField(blank=True, null=True, verbose_name="Equipement nécessaire"),
                ),
                (
                    "access_walk_duration",
                    models.TimeField(
                        blank=True, null=True, verbose_name="Durée de la marche d'accès"
                    ),
                ),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="cave_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "interest",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.Interest",
                        verbose_name="Intérêt pour les chiros",
                    ),
                ),
                (
                    "place",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="sights.Place"
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="cave_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Détail d'une cavité",
                "verbose_name_plural": "Détails des cavités",
                "unique_together": {("visit_date", "place")},
            },
        ),
        migrations.CreateModel(
            name="Build",
            fields=[
                ("id_build", models.AutoField(primary_key=True, serialize=False)),
                ("visit_date", models.DateField(verbose_name="Date de visite")),
                ("cavity_front", models.NullBooleanField(verbose_name="Cavité en façade")),
                ("attic", models.NullBooleanField(verbose_name="Combles présents")),
                ("bell_tower", models.NullBooleanField(verbose_name="Clocher présent")),
                ("bell_tower_screen", models.NullBooleanField(verbose_name="Clocher grillagé")),
                ("cellar", models.NullBooleanField(verbose_name="Cave présente")),
                ("ext_light", models.NullBooleanField(verbose_name="Eclairage extérieur")),
                ("access_light", models.NullBooleanField(verbose_name="Entrées éclairées")),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "attic_access",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        related_name="attic",
                        to="dicts.GiteBatAccess",
                        verbose_name="Accessibilité aux chiroptères",
                    ),
                ),
                (
                    "bell_tower_access",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        related_name="belltower",
                        to="dicts.GiteBatAccess",
                        verbose_name="Accessibilité aux chiroptères",
                    ),
                ),
                (
                    "cellar_access",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        related_name="cellar",
                        to="dicts.GiteBatAccess",
                        verbose_name="Accessibilité aux chiroptères",
                    ),
                ),
                (
                    "cover",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to="dicts.BuildCover",
                        verbose_name="Type de couverture",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="build_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "place",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="sights.Place"
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="build_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Détails d'un pont",
                "verbose_name_plural": "Détails des ponts",
                "unique_together": {("visit_date", "place")},
            },
        ),
        migrations.CreateModel(
            name="Bridge",
            fields=[
                ("id_bridge", models.AutoField(primary_key=True, serialize=False)),
                ("visit_date", models.DateField()),
                ("renovated", models.NullBooleanField(verbose_name="Rénové")),
                (
                    "renovated_date",
                    models.DateField(blank=True, null=True, verbose_name="Date de rénovation"),
                ),
                ("joint", models.NullBooleanField(verbose_name="Joints")),
                ("rift", models.NullBooleanField(verbose_name="Fissures")),
                ("expansion", models.NullBooleanField(verbose_name="Joints de dilatations")),
                ("drain", models.NullBooleanField(verbose_name="Drains")),
                ("cornice", models.NullBooleanField(verbose_name="Corniche")),
                ("volume", models.NullBooleanField(verbose_name="Volume")),
                ("comment", models.TextField(blank=True, null=True, verbose_name="Commentaire")),
                ("bdsource", models.CharField(blank=True, max_length=100, null=True)),
                ("id_bdsource", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "extra_data",
                    models.JSONField(blank=True, null=True),
                ),
                ("timestamp_create", models.DateTimeField(auto_now_add=True)),
                ("timestamp_update", models.DateTimeField(auto_now=True)),
                (
                    "created_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="bridge_creator",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "interest",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dicts.Interest",
                        verbose_name="Intérêt pour les chiros",
                    ),
                ),
                (
                    "place",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="sights.Place"
                    ),
                ),
                (
                    "updated_by",
                    models.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="bridge_modifier",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Détails d'un pont",
                "verbose_name_plural": "Détails des ponts",
                "unique_together": {("visit_date", "place")},
            },
        ),
    ]
